Can you solve this equation? HDU - 2199 (二分)
阿新 • • 發佈:2018-12-18
Can you solve this equation?
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 26314 Accepted Submission(s): 11274
Problem Description
Now,given the equation 8x^4 + 7x^3 + 2x^2 + 3x + 6 == Y,can you find its solution between 0 and 100;
Now please try your lucky.
Input
The first line of the input contains an integer T(1<=T<=100) which means the number of test cases. Then T lines follow, each line has a real number Y (fabs(Y) <= 1e10);
Output
For each test case, you should just output one real number(accurate up to 4 decimal places),which is the solution of the equation,or “No solution!”,if there is no solution for the equation between 0 and 100.
Sample Input
2
100
-4
Sample Output
1.6152
No solution!
Author
Redow
題目的大意是 給定一個關於x的函式f(x),然後再給定一個Y,讓你在 0<=x <=100的範圍內找出一個x使得函式f(x)等於Y
很容易看出來這個函式在0,100間是單調遞增的(那麼我們就採用二分法)
對x的區間不斷的進行二分,直到fab(f(x)-Y)的值逼近一個EPS(一個很小很小的數字)就可以了
AC程式碼如下:
#include <iostream>
#include <cmath>
#include <iomanip>
using namespace std;
double Y;
double Function(double x)
{
return 8*pow(x,4)+7*pow(x,3)+2*pow(x,2)+3*x+6; //用來計算函式值
}
const double EPS=1e-5; //控制精度
double twofen(double low,double high) //二分
{
double mid=(low+high)/2;
while(fabs(Function(mid)-Y)>EPS)
{
if(Function(mid)>Y) //因為是單調遞增的函式,所以如果f(mid)的值比Y大,說明mid在我們想找的x的右邊
high=mid;
else low=mid; //反之
mid=(low+high)/2;
}
return mid;
}
int main()
{
int T;
cin>>T;
while(T--)
{
cin>>Y;
cout<<fixed<<setprecision(4); //控制資料精度為小數點4位
if(Function(0)>Y || Function(100)<Y) //因為是單調遞增的函式,所以如果 當 x=0大於Y的時候,和X=100 小於Y的時候不可能找到解
cout<<"No solution!"<<endl;
else cout<<twofen(0,100)<<endl;
}
return 0;
}